#include "stdafx.h"

#include <iostream>
#include <string>
#include <sstream>
#include <vector>

#include "Person.h"
#include "Employee.h"
#include "Developer.h"

using namespace std;

Developer::Developer(const string& n, int a, double sal, int jg)
	: Employee(n, a, sal, jg),
	  skills(1, "Basic Programming")
{
	cout << "\nDeveloper object created\n";
}

Developer::~Developer()
{	
	cout << "\nGoodbye from Employee dtor\n";
}

string Developer::ToString() const
{
	stringstream stm;
	stm << Employee::ToString() << " ";
	
	vector<string>::const_iterator iter;
	for (iter = skills.begin(); iter != skills.end(); iter++)
	{
		stm << " " << *iter;
	}
	return stm.str();
}

void Developer::AddSkill(const string & skill)
{
	skills.push_back(skill);
}

bool Developer::HasSkill(const string& skill) const
{	
	bool found = false;
	vector<string>::const_iterator iter;
	for (iter = skills.begin(); iter != skills.end(); iter++)
	{
		if (*iter == skill)
		{
			found = true;
			break;
		}
	}
	return found;
}

bool Developer::HasSuperior() const
{
	return true;
}

void Developer::DeductionCut()
{
	salary -= 10;
}